(* Title:  Specify/pre-conds.sml
   Author: Walther Neuper 110226
   (c) due to copyright terms

Operations on models.
*)

signature PRE_CONDITIONS =
sig
  type T
  type input
  val to_string : T -> string

  val check: Rule_Set.T -> term list -> I_Model.T -> 'a -> bool * (bool * term) list (**)
\<^isac_test>\<open>
  val eval: Rule_Set.T -> bool * term -> bool * term
\<close>
end

(**)
structure Pre_Conds(**) : PRE_CONDITIONS(**) =
struct
(**)

(*type unchecked = term list*)
(*type checked = Pre_Conds_Def.T;*)
type T = Pre_Conds_Def.T;  (*= (bool * term) list;*)
type input = string list;

fun to_str (b, t) = pair2str (bool2str b, UnparseC.term t);
fun to_string pres = strs2str' (map (linefeed o to_str) pres);

fun eval _ (false, pre) = (false, pre) (*NOT ALL Free's have been substituted*)
  | eval prls (true, pre) =
    if Rewrite.eval_true (Proof_Context.init_global (ThyC.Isac "")) [pre] prls
    then (true , pre)
    else (false , pre);

fun check _ [] _ _ = (true, [])
  | check prls pres pbl (_ (* FIXME.WN0308 re-introduce I_Model.variants *)) =
    let
      val env = I_Model.environment pbl;
      val pres' = map (TermC.subst_atomic_all env) pres;
      val evals = map (eval prls) pres';
    in (foldl and_ (true, map fst evals), evals) end;

(**)end(**)
