(*  Title:  test/Tools/isac/build_thydata.sml
    Author: Walther Neuper, TU Graz, 2010
    (c) due to copyright terms

theory Test_Some imports Isac.Build_Isac begin 
ML_file "$ISABELLE_ISAC_TEST/Tools/isac/ADDTESTS/accumulate-val/lucas_interpreter.sml"
ML_file "Knowledge/build_thydata.sml"
*)

"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- retrieve errpats ------------------------------------";
"----------- fun collect_part: KILL BY [[ML_print_depth = 999]]---";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";

"----------- retrieve errpats ------------------------------------";
"----------- retrieve errpats ------------------------------------";
"----------- retrieve errpats ------------------------------------";
val {errpats, nrls, scr = Prog prog, ...} = MethodC.from_store ctxt ["diff", "differentiate_on_R"]; 
case errpats of [("chain-rule-diff-both", _, _)] => ()  
  | _ => error "errpats chain-rule-diff-both changed" 

"----------- fun collect_part: KILL BY [[ML_print_depth = 999]]---";
"----------- fun collect_part: KILL BY [[ML_print_depth = 999]]---";
"----------- fun collect_part: KILL BY [[ML_print_depth = 999]]---";
(* "declare [[ML_print_depth = 999]]" *before* opening structure ApplicableOLD
  slows down KEStore_Elems.get_rlss in collect_part in Build_Thydata.thy
  such, that it hangs (probably due to some full buffer)
  test below compiled with
theory Test_Theory
imports "$ISABELLE_ISAC/Knowledge/Isac" "$ISABELLE_ISAC/Interpret/Interpret"
  "$ISABELLE_ISAC/Knowledge/Test_Build_Thydata"
begin                                                                            
*)
(*/----- cp from Build_Thydata.thy -----------------------------------------------------------\*)
  val knowledge_parent = @{theory} (* should be Build_Thydata.thy, replaced by above imports;
    original = {Pure, .., Inverse_Z_Transform, Isac, Test_Build_Thydata, Build_Thydata:12}
    here     = {Pure, .., Inverse_Z_Transform, Isac, Test_Build_Thydata, Test_Theory:111}   *)
  val proglang_parent = @{theory ProgLang}
  val allthys = Theory.ancestors_of @{theory};
  val allthys = filter_out (member Context.eq_thy (* thys for isac bootstrap *)
    [(*@{theory ProgLang}: required in isacthys' below*) @{theory Interpret}, @{theory MathEngine},
    @{theory BridgeLibisabelle}, knowledge_parent]) allthys         (*["Isac_Knowledge", ..., "Pure"]*)
  val isabthys' =                         (*["Complex_Main", "Taylor", .., "Pure"]*)
    drop ((find_index (curry Context.eq_thy @{theory Complex_Main}) allthys), allthys);
  val isacthys' =                         (*["Isac_Knowledge", "Inverse_Z_Transform",  .., "Know_Store"]*)
    take ((find_index (curry Context.eq_thy @{theory Complex_Main}) allthys), allthys);
  val knowthys' =                         (*["Isac_Knowledge", .., "Input_Descript", "Delete"]*)
    take ((find_index (curry Context.eq_thy proglang_parent) isacthys'), isacthys');
  val progthys' =                         (*["Program", "Tools", "ListC", "Know_Store"]*)
    drop ((find_index (curry Context.eq_thy proglang_parent) isacthys') + 1(*ProgLang*), isacthys');
  val isacrlsthms =                      (*length = 460*)
    Thy_Hierarchy.thms_of_rlss @{theory} (KEStore_Elems.get_rlss knowledge_parent) : (ThmC.id * thm) list
  val rlsthmsNOTisac = isacrlsthms       (*length =  36*)
    |> filter (fn (deriv, _) => 
      member op= (map Context.theory_name isabthys') (ThyC.cut_id deriv))
    : (ThmC.id * thm) list
;
(*\----- cp from Build_Thydata.thy -----------------------------------------------------------/*)
(*val thydata_list = ...*)
(map (Thy_Hierarchy.collect_isab "Isabelle") rlsthmsNOTisac);           (* OK *)
Thy_Hierarchy.collect_part   "IsacScripts" proglang_parent progthys';   (* OK *)
(*collect_part "IsacKnowledge" knowledge_parent knowthys' (* NOT terminating *)*)

"~~~~~ fun collect_part , args:"; val (part, parent, thys) =
  ("IsacKnowledge", knowledge_parent, knowthys');
(map (Thy_Hierarchy.collect_thms part) thys);                           (* OK *)
(*(collect_rlss part (KEStore_Elems.get_rlss parent) thys)(* NOT terminating *)*)
(*KEStore_Elems.get_rlss parent                           (* NOT terminating *)*)

"~~~~~ fun get_rlss , args:"; val () = ();
parent; (* = {Pure, .., Inverse_Z_Transform, Isac, Test_Build_Thydata, Test_Theory:111}*)

(*/----- save time in Test_Isac.thy ----------------------------------------------------------
(* rls are stored cumulatively    vvv                 we try them by bisection *)
(*KEStore_Elems.get_rlss @{theory Isac_Knowledge}                   (* NOT terminating *)*)
(*KEStore_Elems.get_rlss @{theory Inverse_Z_Transform}    (* NOT terminating *)*)
  KEStore_Elems.get_rlss @{theory Biegelinie};            (* very very very slow *)
  KEStore_Elems.get_rlss @{theory PolyEq};                (* OK, very very slow *)
  KEStore_Elems.get_rlss @{theory RootRatEq};             (* OK, very slow *)
  KEStore_Elems.get_rlss @{theory RootRat};               (* OK, slow *)
  KEStore_Elems.get_rlss @{theory RootEq};                (* OK *)
  \----- save time in Test_Isac.thy ----------------------------------------------------------/*)
